diff --git a/cluster_library.c b/cluster_library.c
index 0a54be3bb..e2918a434 100644
--- a/cluster_library.c
+++ b/cluster_library.c
@@ -1057,7 +1057,7 @@ void cluster_init_cache(redisCluster *c, redisCachedCluster *cc) {
 PHP_REDIS_API int
 cluster_init_seeds(redisCluster *cluster, HashTable *ht_seeds) {
     RedisSock *redis_sock;
-    char *str, *psep, key[1024];
+    char *str, *pos, *psep, key[1024];
     int key_len, count, i;
     zval **z_seeds, *z_seed;
 
@@ -1078,7 +1078,12 @@ cluster_init_seeds(redisCluster *cluster, HashTable *ht_seeds) {
 
         /* Make sure we have a colon for host:port.  Search right to left in the
          * case of IPv6 */
-        if ((psep = strrchr(str, ':')) == NULL)
+        if ((pos = strstr(str, "://")) == NULL) {
+            psep = strrchr(str, ':');
+        } else {
+            psep = strrchr(pos + 3, ':');
+        }
+        if (psep == NULL)
             continue;
 
         // Allocate a structure for this seed
@@ -1092,8 +1097,11 @@ cluster_init_seeds(redisCluster *cluster, HashTable *ht_seeds) {
         }
 
         // Index this seed by host/port
-        key_len = snprintf(key, sizeof(key), "%s:%u", ZSTR_VAL(redis_sock->host),
-            redis_sock->port);
+        if (pos) {
+            key_len = snprintf(key, sizeof(key), "%.*s:%u", (int)(psep - pos - 3), pos + 3, redis_sock->port);
+        } else {
+            key_len = snprintf(key, sizeof(key), "%s:%u", ZSTR_VAL(redis_sock->host), redis_sock->port);
+        }
 
         // Add to our seed HashTable
         zend_hash_str_update_ptr(cluster->seeds, key, key_len, redis_sock);
